class Animal:

    """An animal representation in PuppyPlace system"""

    def __init__(self, id, date, breed, estimated_age, notes=[]):
        self.id = id
        self.admission_date = date
        self.breed = breed
        self.estimated_age = estimated_age
        for note in notes:
            self.validate_note_type(note)
        self.notes = notes.copy()

    def get_id(self):
        return self.id

    def get_admission_date(self):
        return self.admission_date

    def get_breed(self):
        return self.breed

    def get_estimated_age(self):
        return self.estimated_age

    def get_notes(self):
        return self.notes

    def validate_note_type(self, note):
        if type(note) == str:
            return True
        else:
            raise TypeError("A note should be a string message")

    def add_note(self, note):
        if self.validate_note_type(note):
            self.notes = self.notes + [note]


class Cat(Animal):

    """A cat representation in PuppyPlace system"""

    def __init__(self, id, date, breed, estimated_age, notes=[]):
        Animal.__init__(self, id, date, breed, estimated_age, notes)


class Dog(Animal):

    """A dog representation in PuppyPlace system"""

    def __init__(self, id, date, breed, estimated_age, notes=[]):
        Animal.__init__(self, id, date, breed, estimated_age, notes)