import repository
import model
from datetime import date


class CatService:

    def __init__(self):
        self.repository = repository.Repository()
        self.next_id = 0

    def store(self, breed, estimated_age, notes=[]):
        cat = model.Cat(self.next_id, date.today(), breed, estimated_age, notes)
        self.repository.create_or_update(cat.get_id(), cat)
        self.next_id += 1

    def update(self, cat):
        self.repository.create_or_update(cat.get_id(), cat)

    def remove(self, id):
        self.repository.delete(id)

    def get_by_id(self, id):
        return self.repository.find_by_id(id)

    def all(self):
        return self.repository.all()


class DogService:

    def __init__(self):
        self.repository = repository.Repository()
        self.next_id = 0

    def store(self, breed, estimated_age, notes=[]):
        dog = model.Dog(self.next_id, date.today(), breed, estimated_age, notes)
        self.repository.create_or_update(dog.get_id(), dog)
        self.next_id += 1

    def update(self, dog):
        self.repository.create_or_update(dog.get_id(), dog)

    def remove(self, id):
        self.repository.delete(id)

    def get_by_id(self, id):
        return self.repository.find_by_id(id)

    def all(self):
        return self.repository.all()